<?php
//##############################################################################
//## pSys - Funktionen und Klassen                                            ##
//##############################################################################
//##############################################################################

// table.td - $tdclass odd/even switchen #######################################
function tdswitch ()
{
    global $tdclass;
    if ($tdclass == "odd") {
        $tdclass = "even";
    } else {
        $tdclass = "odd";
    }
}

// Topic Icon anzeigen ##########################################################
function showTicon ($icon)
{
    global $purl_ticons, $pdir_ticons;
    $icon = basename($icon);
    if (file_exists("$pdir_ticons/$icon") and is_file("$pdir_ticons/$icon")) {
        echo "<img src=\"$purl_ticons/$icon\" align=\"middle\" alt=\"$icon\" /> ";
    } else {
        echo "<img src=\"$purl_ticons/icon01.gif\" align=\"middle\" alt=\"icon1\" /> ";
    }
}

// Topic Icon ermitteln ##########################################################
function getTicon ($icon)
{
    global $purl_ticons, $pdir_ticons;
    $icon = basename($icon);
    if (file_exists("$pdir_ticons/$icon") and is_file("$pdir_ticons/$icon")) {
        return "$purl_ticons/$icon";
    } else {
        return "$purl_ticons/icon01.gif";
    }
}

// User Avatar anzeigen ########################################################
function showUserAvatar ($avatar)
{
    global $pdir_avatar, $pdir_avataruser;
    global $purl_avatar, $purl_avataruser;
	if ( strstr( $avatar ,"http://") ) {
    	echo "<img src=\"$avatar\" alt=\"Avatar\">";
    } else {
		$avatar = basename($avatar);
	    // echo "$pdir_avataruser/$avatar";
	    if (file_exists("$pdir_avataruser/$avatar")) {
	        echo "<img src=\"$purl_avataruser/$avatar\" alt=\"$avatar\"> ";
	    }
	    if (file_exists("$pdir_avatar/$avatar")) {
	        echo "<img src=\"$purl_avatar/$avatar\" alt=\"$avatar\"> ";
	    }
	}
}

// User Avatar URL ermitteln ###################################################
function getUserAvatar ($avatar)
{
    global $pdir_avatar, $pdir_avataruser;
    global $purl_avatar, $purl_avataruser;
	if ( strstr( $avatar ,"http://") ) {
    	return $avatar;
    } else {
		$avatar = basename($avatar);
	    if (file_exists("$pdir_avataruser/$avatar")) {
	        return "$purl_avataruser/$avatar";
	    }
	    if (file_exists("$pdir_avatar/$avatar")) {
	        return "$purl_avatar/$avatar";
	    }
	    else {
	        return false;
        }
	}
}
function getGravatar($email){
	$email=trim(strtolower($email));
	$url = "http://www.gravatar.com/avatar/".md5($email);
	return $url;
}

function PStatCount($varname)
{
    global $serverid, $tab_pstat;
    mysql_query("Update $tab_pstat Set valueint=valueint + 1
	             Where varname = '$varname'
				   and stime = CURDATE() ", $serverid);
    echo mysql_error($serverid);
    if (mysql_affected_rows($serverid) == 0) {
        mysql_query("Insert Into $tab_pstat (varname,valueint,stime)
					 Values( '$varname',1,CURRENT_DATE() )", $serverid);
        echo mysql_error($serverid);
    }
    return true;
}

function pfTranslateBoardtyp($boardtyp)
{
    switch ($boardtyp) {
        case "GuestS":
            $btt = "Vollzugriff für User und Gäste";
            break;
        case "GuestR":
            $btt = "Vollzugriff für User, Gäste dürfen antworten";
            break;
        case "GuestL":
            $btt = "Vollzugriff für User, Gäste dürfen nur lesen";
            break;
        case "UserS":
            $btt = "Vollzugriff nur für registrierte User";
            break;
        case "UserR":
            $btt = "Registrierte User dürfen nur antworten. Neue Threads nur mit Sonderrecht";
            break;
        case "UserL":
            $btt = "Registrierte User dürfen nur lesen. Neue Threads nur mit Sonderrecht";
            break;
        case "UserM":
            $btt = "Gäste haben Vollzugriff, Registrierte User können moderieren";
            break;
        case "Private":
            $btt = "Zugriffsberechtigung nur mit Sonderrecht";
            break;
        case "ReadOnly":
            $btt = "Readonly";
            break;
        case "Ticket":
            $btt = "Ticketsystem: Nur selbst gestartete Themen";
            break;
        case "Reply":
            $btt = "Gäste und User können nur antworten";
            break;
    }
    return $btt;
}

function pfTranslateRights($rights)
{
    switch ($rights) {
        case "moderate":
            $btt = "Du darfst moderieren";
            break;
        case "write":
            $btt = "Du darfst neue Themen starten und antworten";
            break;
        case "read":
            $btt = "Du darfst nur lesen";
            break;
        case "reply":
            $btt = "Du darfst antworten und lesen";
            break;
    }
    return $btt;
}

function getAgeByYear($iDays)
{
    $iYears = date("Y", time()) - $iDays;
    // $iYears = floor($iDays / 365.25);
    return $iYears;
}

function paUpdateCatPfad($id) {
    global $serverid, $tab_artcat, $tab_art, $tab_artpage, $pdb;
    $pfad = "";
    $catid = $id;
    while ($catid != 0) {
        $sqlbefehl = "Select subcat,name,id FROM $tab_artcat where id='$catid'";
        $getsubcat = mysql_query($sqlbefehl, $serverid);
        $subcat = mysql_fetch_array ($getsubcat);
        $catid = $subcat[subcat];
        $pfad = " / $subcat[name]" . $pfad;
    }
    $pfad = LanguageTag('PLhome') . $pfad;
    $pfad = $pdb->escape($pfad);
    $pdb->query("update $tab_artcat set pfad='$pfad' where id='$id'");
    $pdb->query("update $tab_art set pfad='$pfad' where catid='$id'");
}

function pashortart($post)
{
    $post = str_replace('"', "'", $post);
    $post = strip_tags(formatART($post, "HTML"));
    // Berechne mal die maximale Länge
    $post = substr($post, 0, 300); //abschneiden
    $pos = strrpos($post, " "); //Letztes " " suchen
    return substr($post, 0, $pos) . "..." ; //zuschneiden
}

function PACatPfad($catid)
{
    $catid=intval($catid);
    global $tab_artcat,$pdb;
    $pfad = "";
    while ($catid != 0) {
        $subcat = $pdb->fetch_row("Select subcat,name,id FROM $tab_artcat where id='$catid'");
        $catid = $subcat['subcat'];
        $pfad = " / " . $subcat['name'] . $pfad;
    }
    $pfad = LanguageTag('PLroot') . $pfad;
    return $pfad;
}

//Kategorie Pfad erzeugen
function pCatPfad($tab,$catid)
{
    global $pdb;
    $pfad = "";
    $catid = intval($catid);
    while ($catid != 0) {
        $subcat = $pdb->fetch_row("Select subcat,name,id FROM $tab where id='$catid'");
        $catid = $subcat['subcat'];
        $pfad = " / $subcat[name]" . $pfad;
    }
    $pfad = LanguageTag('PLroot'). $pfad;
    return $pfad;
}

// Artikel formatieren
function formatART($art, $arttyp)
{
    if ($arttyp == 'bbcode') {
    	$art = formatpost($art);
    } else {
        $art = stripslashes($art);
        $art = preg_replace('#\[code\](.*)\[/code\]#siU', '[code]\1[/code]', $art);
        // ..:: [code]-Teil ausschneiden ::..
        unset($codeparts);
        $x = 0;
        while (preg_match('/\[code\](.+)\[\/code\]/isU', $art)) {
            $codestart = strpos($art, '[code]');
            $codeend = strpos($art, '[/code]', $codestart);
            $codeparts[$x] = substr($art, $codestart + 6, $codeend - ($codestart + 6));
            $art = str_replace('[code]' . $codeparts[$x] . '[/code]', '[codepart-' . $x . ']', $art);
            $x++;
        }
        // Format
        if ($arttyp == "txt") {
            // $art= htmlspecialchars($art);
            $art = nl2br($art);
            // $art = stripslashes($art);
            $art = urlparse($art);
            $art = HRCparse($art);
        } else {
            // $art = stripslashes($art);
        }
        // Code
        // ..:: [code]-Teil einfügen ::..
        $x = count($codeparts)-1;
        for($i = 0;$i <= $x;$i++) {
            $art = str_replace('[codepart-' . $i . ']', php_highlight($codeparts[$i]), $art);
        }
    }
    $art = parse_glossar($art);
    return $art;
}

function pOutHTML($html)
{
    $html = stripslashes($html);
    $html = parse_glossar($html);
    echo $html;
}

function formatstring($post)
{
    // $post= stripslashes($post);
    $post = htmlspecialchars($post);
    $post = nl2br($post);
    return $post;
}
// ....:::: PHP-Highlightning v3 by mahe - 27.01.2005 ::::....
if (!function_exists('php_highlight')) {
    function php_highlight($code)
    {
        $code = trim($code);
        ob_start();
        highlight_string($code);
        $buffer = ob_get_contents();
        ob_end_clean();
        $buffer = str_replace('<code>', '', $buffer);
        $buffer = str_replace('</code>', '', $buffer);
        $znr = '';
        $rows = count(explode('<br />', $buffer));
        for($i = 1; $i <= $rows; $i++) {
            $znr .= "$i:<br />";
        }
        $znr = '<code>' . substr($znr, 0, (strlen($znr)-6)) . '</code>';
        $buffer = '<code><nobr>' . $buffer . '</nobr></code>';
        if ($i > 16) {
            $height = $i * 12-1;
            if ($height > 530) {
                $height = 530;
            }
            $height = ' height: ' . $height . 'px;';
        } else {
            $height = '';
        }
        return '<div style="overflow: auto;' . $height . ' width: 100%; border: 1px solid #000000;">
        <table style="width: 100%;" cellspacing="0">
            <tr>
                <td style="text-align: right; width: 25px; background: #AFAFAF; border-right: 1px solid #000000;">
                    ' . $znr . '
                </td>
                <td style="background: #EFEFEF;">
                    ' . $buffer . '
                </td>
            </tr>
        </table>
        </div>';
    }
}
// Kommentare formatieren #######################################################
function formatkom($post)
{
    global $purl_smilies;
    $post = stripslashes($post);
    $post = htmlspecialchars($post);
    $post = nl2br($post);
    $post = str_replace(":-)", "<img align=\"absmiddle\" alt=\":-)\" src=\"$purl_smilies/smile01.gif\">", $post);
    $post = str_replace(";-)", "<img align=\"absmiddle\" alt=\";-)\" src=\"$purl_smilies/smile02.gif\">", $post);
    $post = str_replace(":O", "<img align=\"absmiddle\" alt=\":O\" src=\"$purl_smilies/smile03.gif\">", $post);
    $post = str_replace(";-(", "<img align=\"absmiddle\" alt=\";-(\" src=\"$purl_smilies/smile04.gif\">", $post);
    $post = str_replace(":D", "<img align=\"absmiddle\" alt=\":D\" src=\"$purl_smilies/smile05.gif\">", $post);
    $post = str_replace("8-)", "<img align=\"absmiddle\" alt=\"8-)\" src=\"$purl_smilies/smile06.gif\">", $post);
    $post = str_replace(":-O", "<img align=\"absmiddle\" alt=\":-O\" src=\"$purl_smilies/smile07.gif\">", $post);
    $post = str_replace(":-(", "<img align=\"absmiddle\" alt=\":-(\" src=\"$purl_smilies/smile08.gif\">", $post);
    $post = str_replace("(?)", "<img align=\"absmiddle\" alt=\"(?)\" src=\"$purl_smilies/smile09.gif\">", $post);
    $post = str_replace("(!)", "<img align=\"absmiddle\" alt=\"(!)\" src=\"$purl_smilies/smile10.gif\">", $post);
    return $post;
}

function PageSwitcher($eintragaktuell, $zps, $gesamt, $linkstring)
{
    global $smarty_core;
    //für Kompatibilität den <a href entfernen
    $linkstring = str_ireplace('<a href="','' ,$linkstring);
    $maxsites = 10;
    $eintrag = "0";
    $seite = "1";
    $count = 1;
    $smarty_core->assign('pager_eintragaktuell',intval($eintragaktuell));
    $smarty_core->assign('pager_link',$linkstring);
    $eintrag = $eintragaktuell;
    $aktseite = ($eintragaktuell + $zps) / $zps;
    $seite = $aktseite - ($maxsites/2);
    if ($seite < 1) {
        $seite = 1;
    }
    $eintrag = ($seite * $zps) - $zps;
    if ($seite > 1) {
        $s['page'] =1;
        $s['eintrag'] =0;
        $sp[]=$s;
    }
    while ($eintrag < $gesamt) {
        // $bis = $eintrag+$tps;
        $s['page'] = $seite;
        $s['eintrag'] = $eintrag;
        $sp[]=$s;
        $eintrag = ($eintrag + $zps);
        ++$seite;
        ++$count;
        if ( $seite > ($aktseite + $maxsites) or $count > ($maxsites+1)) {
            break;
        }
    }
    //Maximal letzte Seite
    $lastpage = ceil($gesamt / $zps);
    $eintrag = ($lastpage * $zps) - $zps;
    if ($lastpage > $seite) {
        $smarty_core->assign('pager_maxpage',$lastpage);
        $smarty_core->assign('pager_maxeintrag',$eintrag);
    }
    $smarty_core->assign('pager_page',$sp);
    return $smarty_core->fetch('core_pager.tpl');
} //Ende PageSwitcher

function PageSwitcherAlt($eintragaktuell, $zps, $gesamt, $linkstring)
{
    $maxsites = 10;
    $eintrag = "0";
    $seite = "1";
    $seitenanzeige = "Seite: ";
    $eintrag = $eintragaktuell;
    $aktseite = ($eintragaktuell + $zps) / $zps;
    $seite = $aktseite - $maxsites;
    if ($seite < 1) {
        $seite = 1;
    }
    $eintrag = ($seite * $zps) - $zps;
    if ($seite < 1) {
        $seite = 1;
    }
    if ($seite > 1) {
        $seitenanzeige = $seitenanzeige . "$linkstring=0\">1</a> << ";
    } while ($eintrag < $gesamt) {
        // $bis = $eintrag+$tps;
        if ($eintrag == $eintragaktuell) {
            $seitenanzeige = $seitenanzeige . " <b>[$seite]</b> ";
        } else {
            $seitenanzeige = $seitenanzeige . " $linkstring=$eintrag\">$seite</a>";
        }
        $eintrag = ($eintrag + $zps);
        $seite = $seite + 1;
        if ($seite > ($aktseite + $maxsites)) {
            $seitenanzeige = $seitenanzeige . " >> ";
            break;
        }
    }
    $lastpage = ceil($gesamt / $zps);
    $eintrag = ($lastpage * $zps) - $zps;
    if ($lastpage > $seite) {
        $seitenanzeige = $seitenanzeige . " $linkstring=$eintrag\">$lastpage</a>";
    }
    return $seitenanzeige;
} //Ende PageSwitcher

// ###################### URLS Parsen #######################
function urlparse($post)
{
    $urlSA = array('#([^]_a-z0-9-="\'/])((https?|ut2004|ut2003|teamspeak|ed2k|unreal|ftp|gopher|news|telnet)://|www\.)([^ \r\n\(\)\*\^\$!`"\'\|\[\]\{\}<>]*)#si',
        '#^((https?|ut2004|ut2003|teamspeak|ed2k|unreal|ftp|gopher|news|telnet)://|www\.)([^ \r\n\(\)\*\^\$!`"\'\|\[\]\{\}<>]*)#si'
        );

    $urlRA = array('\\1[url]\2\4[/url]',
        '[url]\1\3[/url]'
        );

    $emailSA = array("/([ \n\r\t])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,4}))/si",
        "/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,4}))/si"
        );

    $emailRA = array("\\1[email]\\2[/email]",
        "[email]\\0[/email]"
        );

    $text = preg_replace($urlSA, $urlRA, $post);
    if (strpos($text, "@")) {
        $text = preg_replace($emailSA, $emailRA, $text);
    }
    return $text;
}

// ..:: HRC-Codes parsen ::..
function HRCparse($text)
{
	//YT
	$text = preg_replace("#\[youtube\]http://(www\.)?youtube.com/watch\?v=([A-Za-z0-9\-\_]+)\[/youtube\]#i", "<object width=\"425\" height=\"350\"><param name=\"movie\" value=\"http://www.youtube.com/v/$2\"></param><embed src=\"http://www.youtube.com/v/$2\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\"></embed></object>", $text);
	//php:func
	//$text = preg_replace("#php:([A-Za-z0-9\-\_]+)\(\)#i", "<a href=\"http://de.php.net/$1\" target=\"_blank\">$1</a>", $text);
	$text = preg_replace("#php:(([A-Za-z0-9\-\_]+)\(\))#i", "<a href=\"http://de.php.net/$2\" target=\"_blank\">$1</a>", $text);

	// Images auch im anderen Format zulassen, denn das selbe würde man mit
    // mod_rewrite auch erreichen: Dieses lässt nur mit IMG Extension zu.
    $search = array('/\[b](.*)\[\/b\]/siU',
        '/\[i](.*)\[\/i\]/siU',
        '/\[u](.*)\[\/u\]/siU',
        '/\[center](.*)\[\/center\]/siU',
        '/\[img](.*\.(jpg|jpeg|gif|png|bmp|tif|tiff))\[\/img\]/siU',
        '/\[edit](.*)\[\/edit\]/siU',
        '#\[color=([\w|\#\d]*?)\](.*?)\[/color\]#si',
        '#\[size=([\w]*?)\](.*?)\[/size\]#si',
        '#\[url=(.*?)\](.*?)\[/url\]#si',
        '#\[url\]www.(.*?)\[/url\]#si',
        '#\[url\](.*?)\[/url]#si',
        '#\[email\](.*?)\[/email\]#si',
        '#\[ot\](.*?)\[/ot\]#si'
        );
    $replace = array('<b>\\1</b>',
        '<i>\\1</i>',
        '<u>\\1</u>',
        '<center>\\1</center>',
        '<img border="0" src="\\1">',
        '<table width="95%" align="center"><tr><td><font size="1"><b>Nachtrag:</b></font></td></tr><tr><td class="left" style="border: 1px solid;">\\1</td></tr></table>',
        '<span style="color:\1">\2</span>',
        '<span style="font-size:\1">\2</span>',
        '<a href="\1" target="_blank">\2</a>',
        '<a href="http://www.\1" target="_blank">\1</a>',
        '<a href="\1" target="_blank">\1</a>',
        '<a href="mailto:\1">\1</a>',
        '<fieldset><legend>Off Topic</legend>\\1</fieldset>'
        );
    $text = preg_replace($search, $replace, $text);
    $text = str_replace("[hr]", "<hr>", $text);

    while (preg_match('/\[quote\](.+)\[\/quote\]/isU', $text)) {
        $text = preg_replace('/\[quote](.*)\[\/quote\]/siU',
            '<table class="quote" width="95%" align="center"><tr><td><font size="1"><b>Zitat:</b></font></td></tr><tr><td class="quote">\\1</td></tr></table>',
            $text);
    }
    return $text;
}

function formatquick($post, $size = 15)
{
    global $purl_smilies;
    $post = stripslashes($post);
    $post = htmlspecialchars($post);
    $post = nl2br($post);
    // Smileys:
    // str_replace("altes-zeichen","neues-zeichen","zeichenkette");
    if ($size == 15) {
        $post = str_replace(":-)", "<img border=\"0\" src=\"$purl_smilies/smile01.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(";-)", "<img border=\"0\" src=\"$purl_smilies/smile02.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":O", "<img border=\"0\" src=\"$purl_smilies/smile03.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(";-(", "<img border=\"0\" src=\"$purl_smilies/smile04.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":D", "<img border=\"0\" src=\"$purl_smilies/smile05.gif\" alt=\"s\" /> ", $post);
        $post = str_replace("8-)", "<img border=\"0\" src=\"$purl_smilies/smile06.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":-O", "<img border=\"0\" src=\"$purl_smilies/smile07.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":-(", "<img border=\"0\" src=\"$purl_smilies/smile08.gif\" alt=\"s\" /> ", $post);
        $post = str_replace("(?)", "<img border=\"0\" src=\"$purl_smilies/smile09.gif\" alt=\"s\" /> ", $post);
        $post = str_replace("(!)", "<img border=\"0\" src=\"$purl_smilies/smile10.gif\" alt=\"s\" /> ", $post);
    } else {
        $post = str_replace(":-)", "<img border=\"0\" src=\"$purl_smilies/minis01.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(";-)", "<img border=\"0\" src=\"$purl_smilies/minis02.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":O", "<img border=\"0\" src=\"$purl_smilies/minis03.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(";-(", "<img border=\"0\" src=\"$purl_smilies/minis04.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":D", "<img border=\"0\" src=\"$purl_smilies/minis05.gif\" alt=\"s\" /> ", $post);
        $post = str_replace("8-)", "<img border=\"0\" src=\"$purl_smilies/minis06.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":-O", "<img border=\"0\" src=\"$purl_smilies/minis07.gif\" alt=\"s\" /> ", $post);
        $post = str_replace(":-(", "<img border=\"0\" src=\"$purl_smilies/minis08.gif\" alt=\"s\" /> ", $post);
        $post = str_replace("(?)", "<img border=\"0\" src=\"$purl_smilies/minis09.gif\" alt=\"s\" /> ", $post);
        $post = str_replace("(!)", "<img border=\"0\" src=\"$purl_smilies/minis10.gif\" alt=\"s\" /> ", $post);
    }
    // URLS in HRC umwandeln:
    $post = eregi_replace("([ \r\n])http://([^ ,\r\n]*)", "\\1[url]http://\\2[/url]", $post);
    $post = eregi_replace("([ \r\n])https://([^ ,\r\n]*)", "\\1[url]https://\\2[/url]", $post);
    $post = eregi_replace("([ \r\n])ftp://([^ ,\r\n]*)", "\\1[url]ftp://\\2[/url]", $post);
    $post = eregi_replace("([ \r\n])www\\.([^ ,\r\n]*)", "\\1[url]http://www.\\2[/url]", $post);
    $post = eregi_replace("^http://([^ ,\r\n]*)", "[url]http://\\1[/url]", $post);
    $post = eregi_replace("^https://([^ ,\r\n]*)", "[url]https://\\1[/url]", $post);
    $post = eregi_replace("^ftp://([^ ,\r\n]*)", "[url]ftp://\\1[/url]", $post);
    $post = eregi_replace("^www\\.([^ ,\r\n]*)", "[url]http://www.\\1[/url]", $post);
    // ######### HRC Codes:
    $post = str_replace("[hr]", "<hr>", $post);
    $post = str_replace("[b]", "<b>", $post);
    $post = str_replace("[/b]", "</b>", $post);
    $post = str_replace("[i]", "<i>", $post);
    $post = str_replace("[/i]", "</i>", $post);
    $post = str_replace("[img]", "<img src=", $post);
    $post = str_replace("[/img]", "> ", $post);
    // [URL]
    $post = eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" target=_blank>\\1</a>", $post);
    $post = eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]", "<a href=\"\\1\" target=_blank>\\1</a>", $post);
    // [URL=
    $post = eregi_replace("\\[url=\"([^\"]*)\"\\]([^\\[]*)\\[\\/url\\]", "<a href=\"\\1\" target=_blank>\\2</a>", $post);
    $post = eregi_replace("\\[url=([^\"]*)\\]([^\\[]*)\\[\\/url\\]", "<a href=\"\\1\" target=_blank>\\2</a>", $post);
    $post = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\1</a>", $post);
    // ########## Ende HRC Codes
    return $post;
}

function formatqstring($post)
{
    $post = stripslashes($post);
    $post = htmlspecialchars($post);
    return $post;
}

function pmailkrypt($mail)
{
    $mail = str_replace(".", " <i>dot</i> ", $mail);
    $mail = str_replace("@", " <i>at</i> ", $mail);
    return $mail;
}

// pdate
// Formatiert eine Zeitangabe aus einen Unix Timestamp unter Verwendung von
// PSL_datetime
function pdate($timestamp)
{
    global $time_offset;
    $timestamp = $timestamp + $time_offset;
    // ####### Ermitteln des Zeitstempels heute, null Uhr ###########
    $nulluhr = mktime(0, 0, 0, date("m"), date("d"), date("y")) + 3600;
    if ($timestamp > time()) {
        $date = date(PSL_datetime, $timestamp);
    } elseif ($timestamp >= $nulluhr-3600) {
        $sekunden = $timestamp - $nulluhr;
        $date = PSL_today.", " . date(PSL_timesec, $sekunden);
    } elseif ($timestamp >= ($nulluhr-86400-3600)) {
        $sekunden = $timestamp - ($nulluhr-86400);
        $date = PSL_yesterday.", " . date(PSL_timesec, $sekunden);
    } else {
        $date = date(PSL_datetime, $timestamp);
    }
    return $date;
}

function pdatum($timestamp)
{
    global $time_offset;
    $timestamp = $timestamp + $time_offset;
    $date = date("d.m.Y", $timestamp);
    return $date;
}

function pfaddslashes($st)
{
    if (get_magic_quotes_gpc() == 1) {
        return $st;
    } else {
        return AddSlashes($st);
    }
}

function formatnews($post, $typ)
{
    global $scripturl;
    $post = stripslashes($post);
    if ($typ == "txt") {
        $post = htmlspecialchars($post);
    }
    if ($typ == "txt") {
        $post = nl2br($post);
        // URLS in HRC umwandeln:
        $post = eregi_replace("([ \r\n])http://([^ ,\r\n]*)", "\\1[url]http://\\2[/url]", $post);
        $post = eregi_replace("([ \r\n])https://([^ ,\r\n]*)", "\\1[url]https://\\2[/url]", $post);
        $post = eregi_replace("([ \r\n])ftp://([^ ,\r\n]*)", "\\1[url]ftp://\\2[/url]", $post);
        $post = eregi_replace("([ \r\n])www\\.([^ ,\r\n]*)", "\\1[url]http://www.\\2[/url]", $post);
        $post = eregi_replace("^http://([^ ,\r\n]*)", "[url]http://\\1[/url]", $post);
        $post = eregi_replace("^https://([^ ,\r\n]*)", "[url]https://\\1[/url]", $post);
        $post = eregi_replace("^ftp://([^ ,\r\n]*)", "[url]ftp://\\1[/url]", $post);
        $post = eregi_replace("^www\\.([^ ,\r\n]*)", "[url]http://www.\\1[/url]", $post);
        // ######### HRC Codes:
        $search = array('!\[b\](.*)\[/b\]!siU',/* bold text */
            '!\[i\](.*)\[/i\]!siU',/* italic text */
            '!\[u\](.*)\[/u\]!siU',/* underline text */
            '!\[center\](.*)\[/center\]!siU',/* centered text */
            '!\[url\](.*)\[/url\]!siU',
            '!\[url=(.*)\](.*)\[/url\]!siU',/* links */
            '!\[email\](.*)\[/email\]!siU',
            '!\[email=(.*)](.*)\[/email\]!siU',/* email */
            '!\[img=(http://.*)\]!isU'/* image */
            );
        $replace = array('<span style="font-weight: bold;">\1</span>',/* bold text */
            '<span style="font-style: italic;">\1</span>',/* italic text */
            '<span style="text-decoration: underline;">\1</span>',/* underlined text */
            '<div style="text-align: center;">\1</div>',/* centered text */
            '<a href="\1" target="_blank">\1</a>',
            '<a href="\1" target="_blank">\2</a>',/* links */
            '<a href="mailto:\1">\1</a>',
            '<a href="mailto:\1">\1</a>',/* email */
            '<img src="\1" alt="pic" />'/* image */
            );
        $post = preg_replace($search, $replace, $post);
        $post = str_replace("[hr]", "<hr>", $post);
    }
    // Smile
    $post = str_replace(":-)", "<img src=\"$scripturl/smile01.gif\" alt=\"s\" />", $post);
    $post = str_replace(";-)", "<img src=\"$scripturl/smile02.gif\" alt=\"s\" />", $post);
    $post = str_replace(":O", "<img src=\"$scripturl/smile03.gif\" alt=\"s\" />", $post);
    $post = str_replace(";-(", "<img src=\"$scripturl/smile04.gif\" alt=\"s\" />", $post);
    $post = str_replace(":D", "<img src=\"$scripturl/smile05.gif\" alt=\"s\" />", $post);
    $post = str_replace("8-)", "<img src=\"$scripturl/smile06.gif\" alt=\"s\" />", $post);
    $post = str_replace(":-O", "<img src=\"$scripturl/smile07.gif\" alt=\"s\" />", $post);
    $post = str_replace(":-(", "<img src=\"$scripturl/smile08.gif\" alt=\"s\" />", $post);
    $post = str_replace("(?)", "<img src=\"$scripturl/smile09.gif\" alt=\"s\" />", $post);
    $post = str_replace("(!)", "<img src=\"$scripturl/smile10.gif\" alt=\"s\" />", $post);

    return $post;
}


//function formatblog($post) {
//    global $blogurl;
//    $post = stripslashes($post);
    // $post= htmlspecialchars($post);
    // $post= nl2br($post);
    // Smileys:
    // str_replace("altes-zeichen","neues-zeichen","zeichenkette");
	/*
    $post = str_replace(":-)", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile01.gif\"> ", $post);
    $post = str_replace(";-)", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile02.gif\"> ", $post);
    $post = str_replace(":O", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile03.gif\"> ", $post);
    $post = str_replace(";-(", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile04.gif\"> ", $post);
    $post = str_replace(":D", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile05.gif\"> ", $post);
    $post = str_replace("8-)", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile06.gif\"> ", $post);
    $post = str_replace(":-O", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile07.gif\"> ", $post);
    $post = str_replace(":-(", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile08.gif\"> ", $post);
    $post = str_replace("(?)", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile09.gif\"> ", $post);
    $post = str_replace("(!)", "<img align=\"absmiddle\" border=\"0\" src=\"$blogurl/smile10.gif\"> ", $post);
    // URLS in HRC umwandeln:
    $post = eregi_replace("([ \r\n])http://([^ ,\r\n]*)", "\\1[url]http://\\2[/url]", $post);
    $post = eregi_replace("([ \r\n])https://([^ ,\r\n]*)", "\\1[url]https://\\2[/url]", $post);
    $post = eregi_replace("([ \r\n])ftp://([^ ,\r\n]*)", "\\1[url]ftp://\\2[/url]", $post);
    $post = eregi_replace("([ \r\n])www\\.([^ ,\r\n]*)", "\\1[url]http://www.\\2[/url]", $post);
    $post = eregi_replace("^http://([^ ,\r\n]*)", "[url]http://\\1[/url]", $post);
    $post = eregi_replace("^https://([^ ,\r\n]*)", "[url]https://\\1[/url]", $post);
    $post = eregi_replace("^ftp://([^ ,\r\n]*)", "[url]ftp://\\1[/url]", $post);
    $post = eregi_replace("^www\\.([^ ,\r\n]*)", "[url]http://www.\\1[/url]", $post);
    // ######### HRC Codes:
    $post = str_replace("[hr]", "<hr>", $post);
    $post = str_replace("[b]", "<b>", $post);
    $post = str_replace("[/b]", "</b>", $post);
    $post = str_replace("[i]", "<i>", $post);
    $post = str_replace("[/i]", "</i>", $post);
    $post = str_replace("[img]", "<img border=0 src=", $post);
    $post = str_replace("[/img]", "> ", $post);
    // [URL]
    $post = eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" target=_blank>\\1</a>", $post);
    $post = eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]", "<a href=\"\\1\" target=_blank>\\1</a>", $post);
    // [URL=
    $post = eregi_replace("\\[url=\"([^\"]*)\"\\]([^\\[]*)\\[\\/url\\]", "<a href=\"\\1\" target=_blank>\\2</a>", $post);
    $post = eregi_replace("\\[url=([^\"]*)\\]([^\\[]*)\\[\\/url\\]", "<a href=\"\\1\" target=_blank>\\2</a>", $post);
    $post = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\1</a>", $post);
    // ########## Ende HRC Codes
	*/
    //return $post;
//}

function formatblogkom($post)
{
    $post = stripslashes($post);
    $post = htmlspecialchars($post);
    $post = nl2br($post);
    // Smileys:
    // str_replace("altes-zeichen","neues-zeichen","zeichenkette");
    $post = str_replace(":-)", "<img align=\"absmiddle\" src=\"smile01.gif\">", $post);
    $post = str_replace(";-)", "<img align=\"absmiddle\" src=\"smile02.gif\">", $post);
    $post = str_replace(":O", "<img align=\"absmiddle\" src=\"smile03.gif\">", $post);
    $post = str_replace(";-(", "<img align=\"absmiddle\" src=\"smile04.gif\">", $post);
    $post = str_replace(":D", "<img align=\"absmiddle\" src=\"smile05.gif\">", $post);
    $post = str_replace("8-)", "<img align=\"absmiddle\" src=\"smile06.gif\">", $post);
    $post = str_replace(":-O", "<img align=\"absmiddle\" src=\"smile07.gif\">", $post);
    $post = str_replace(":-(", "<img align=\"absmiddle\" src=\"smile08.gif\">", $post);
    $post = str_replace("(?)", "<img align=\"absmiddle\" src=\"smile09.gif\">", $post);
    $post = str_replace("(!)", "<img align=\"absmiddle\" src=\"smile10.gif\">", $post);

    return $post;
}

function mysql_field_exist($db, $table, $field, $serverid)
{
    $fields = mysql_list_fields($db, $table, $serverid);
    $columns = mysql_num_fields($fields);
    $found = 0;
    for ($i = 0; $i < $columns; $i++) {
        if (trim($field) == trim(mysql_field_name($fields, $i))) $found = 1;
    }
    return $found;
}

function pfshortpost($post)
{
    $post = str_replace('"', "'", $post);
    $post = strip_tags(formatpost($post));
    // Berechne mal die maximale Länge
    if (strlen($post) > 300) {
        $post = substr($post, 0, 300); //abschneiden
        $pos = strrpos($post, " "); //Letztes " " suchen
        $post = substr($post, 0, $pos) . "..."; //zuschneiden
    }
    return $post;
}

function pfshowrating($rating)
{
    global $purl_images;
    $rate = floor($rating / 2);
    if ($rate > 0 and $rate < 6) {
        echo "<img src=\"$purl_images/rating$rate.gif\" border=\"0\" alt=\"rate\" title=\"Bewertung: $rating\">";
    }
}

//Thread Rating liefern
function getThreadRating($thread)
{
    if ($thread['votezahl'] > 0) {
        $wert = $thread['votepunkte'] / $thread['votezahl'];
        if ($wert == 0) {
            $wert = 1;
        }
        $punkte = intval($wert);
        global $purl_images;
        $rate = floor($punkte / 2);
        if ($rate > 0 and $rate < 6) {
            return "<img src=\"$purl_images/rating$rate.gif\" border=\"0\" alt=\"rate\" title=\"$rating\">";
        }
    } else {
        return false;
    }
}

function getAgeByDays($iDays)
{
    $iYears = floor($iDays / 365.25);
    return $iYears;
}

function getAge($day, $month, $year)
{
    $now = time();
    if (date("Y", $now) == $year
            and date("m", $now) == $month
            and date("d", $now) == $day) {
        $result = 0;
    } else {
        $result = date("Y", $now) - $year;
        if ($month > date("m", $now)) {
            // Geburtstag war noch nicht
            $result--;
        } elseif ($month == date("m", $now)) {
            // Geburtstag ist im aktuellen Monat...
            if ($day > date("d", $now)) {
                // ...aber erst in ein paar Tagen
                $result--;
            }
        }
    }
    return $result;
}

function getuserstat($posts)
{
    $status = "neuer User";
    if ($posts > 0) $status = "Einmalposter";
    if ($posts > 1) $status = "Neuer User";
    if ($posts > 20) $status = "Member";
    if ($posts > 50) $status = "Supermember";
    if ($posts > 100) $status = "Hardcoreposter";
    if ($posts > 199) $status = "Fingerwundschreiber";
    if ($posts > 300) $status = "Spambot";
    if ($posts > 500) $status = "Dr. Forum";
    if ($posts > 699) $status = "Scriptkiller";
    if ($posts > 999) $status = "Lord Forum";
    if ($posts > 2000) $status = "Alleswisser";
    return $status;
}

function lastforward()
{
    global $s_lastact;
    global $forumurl;
    if ($s_lastact[typ] == '') {
        header ("Location: $forumurl/index.php");
        exit;
    } else {
        $location = $forumurl . "/" . $s_lastact[typ] . ".php?id=" . $s_lastact[id];
        header ("Location: $location");
        exit;
    }
}
// ###################### Loging ###############################################
function do_log($refid, $typ, $logtext)
{
    global $serverid;
    global $user_id;
    global $tab_log;
    $time = time();
    $host = getenv("REMOTE_ADDR");
    $sqlbefehl = "Insert Into $tab_log (userid,ip,refid,typ,time,logtext)
                Values ('$user_id','$host','$refid','$typ','$time','$logtext')";
    mysql_query($sqlbefehl, $serverid);
}

function getsmilies()
{
    global $tab_smilies, $serverid, $smile, $purl_smilies;
    $getsmile = mysql_query("SELECT * FROM $tab_smilies order by sorted", $serverid);
    for ($i = 0; $data = mysql_fetch_array($getsmile); $i++) {
        if ($data['id'] < 10) {
            $file = 'dsmile0' . $data['id'] . $data['type'];
        } else {
            $file = 'dsmile' . $data['id'] . $data['type'];
        }
        $smile[$i]['code'] = $data['code'];
        $smile[$i]['replace'] = '<img src="' . $purl_smilies . '/' . $file . '" border="0" title="' . $data['descr'] . '" align="absmiddle">';
    }
}

function parse_glossar($var)
{
	global $pgls, $tab_glossar, $serverid;
	if ( !isset($pgls ) ) {
	    $getg = mysql_query("SELECT word,description From $tab_glossar", $serverid);
	    $i = 0;
	    while( $gl = mysql_fetch_assoc($getg)){
	    	$pgls[] = '#([ \n\r\t])('.$gl['word'].')([ \n\r\t])#siU';
	    	$pglr[] = '\1<a class="glossar" title="'.strip_tags($gl['description']).'">\2</a>\3';
	    	$i++;
	    } // while
	}
	if ( $pgls != "" ) {
		$var = preg_replace($pgls,$pglr,$var);
	}
	return $var;
}

function formatpost($post)
{
    global $smile, $usesmile;
    if ($usesmile == "") {
        $usesmile = 1;
    }
    // $post= stripslashes($post);
    $post = preg_replace('#\[code\](.*)\[/code\]#siU', '[code]\1[/code]', $post);
    // ..:: [code]-Teil ausschneiden ::..
    unset($codeparts);
    $x = 0;
    while (preg_match('/\[code\](.+)\[\/code\]/isU', $post)) {
        $codestart = strpos($post, '[code]');
        // $codeend   = strpos($post,'[/code]');
        $codeend = strpos($post, '[/code]', $codestart);
        $codeparts[$x] = substr($post, $codestart + 6, $codeend - ($codestart + 6));
        $post = str_replace('[code]' . $codeparts[$x] . '[/code]', '[codepart-' . $x . ']', $post);
        $x++;
    }

    $post = htmlspecialchars($post);
    $post = nl2br($post);
    // Security:
    $post = str_replace("javascript:", "java script:", $post);
    if (!empty($_GET['highlight'])) {
        $post = search_highlight($post);
    }
    // Smilies:
    if ($usesmile == 1) {
        if (!isset($smile) or !is_array($smile)) {
            getsmilies(); // Liest die Smilies aus der DB wenn das noch nicht geschehen ist.
        }
        if ( count($smile) > 0 ) {
	        foreach($smile as $asmilies) {
	            $post = str_replace($asmilies['code'], $asmilies['replace'], $post);
	        }
        }
    }
    // URLS in HRC umwandeln:
    $post = urlparse($post);
    // ######### HRC Codes:
    $post = HRCparse($post);
    // ..:: [code]-Teil einfügen ::..
    $x = count($codeparts)-1;
    for($i = 0;$i <= $x;$i++) {
        $post = str_replace('[codepart-' . $i . ']', php_highlight($codeparts[$i]), $post);
    }
    return $post;
}

// EMail Adresse prüfen
/*
function isemail ($mail) {
	if (!preg_match("/^( [a-zA-Z0-9] )+( [a-zA-Z0-9\._-] )*@( [a-zA-Z0-9_-] )+( [a-zA-Z0-9\._-] +)+$/" , $email)) {
		return 0;
	} else {
        return 1;
    }
}*/
function isemail ($mail)
{
	if (!eregi("^[\&_\.0-9a-z-]+@([\.0-9a-z][\.0-9a-z-]+\.)+[a-z]{2,4}$", $mail)) {
		return 0;
		// Mailadresse sieht seltsam aus
	} else {
		return 1;
	}
}


// Karma anzeigen
function showkarma($punkte)
{
    global $purl_images;
    if ($punkte > 401) $punkte = 401;
    if ($punkte < -401) $punkte = -401;

    if ($punkte > 400) {
        $title = "Mehr geht leider nicht";
    } elseif ($punkte > 0) {
        $title = "Alles im grünen Bereich";
    } elseif ($punkte == 0) {
        $title = "Noch nichts verdient";
    } elseif ($punkte < 0) {
        $title = "Schlechtes Jahr erwischt";
    } elseif ($punkte < -400) {
        $title = "Schlechter Tag erwischt";
    }
    // $punkte =  $punkte/15;
    echo "<table width=\"142\" height=\"10\" border=\"1\" cellspacing=\"0\" class=\"no\">
    <tr>
    <td width=\"140\" bgcolor=\"#000000\" align=\"left\" title=\"$title\">";
    if ($punkte > 0) {
        for($i = 0; $i < $punkte / 16; $i++) {
            echo "<img src=\"$purl_images/plus.gif\" border=\"0\">";
        }
        if ($punkte > 400) {
            echo "<img src=\"$purl_images/plusmax.gif\" border=\"0\">";
        }
    }
    if ($punkte < 0) {
        for($i = 0; $i > $punkte / 16; $i--) {
            echo "<img src=\"$purl_images/minus.gif\" border=\"0\">";
        }
        if ($punkte < -400) {
            echo "<img src=\"$purl_images/minusmax.gif\" border=\"0\">";
        }
    }
    if ($punkte == 0) {
        echo "<img src=\"$purl_images/null.gif\" border=\"0\">";
    }
    echo "</td></tr></table>";
}

//Nachrichten Box
function msgBox($text,$title="",$typ="")
{
    global $pset, $purl_images, $smarty_core;
    if ( $title == "") {
    	$title=$pset['systitle'];
    }
    $smarty_core->assign('title',$title);
    $smarty_core->assign('text',$text);
    if ( $typ == 'error') {
        $smarty_core->display('msgbox_error.tpl');
    } else {
        $smarty_core->display('msgbox.tpl');
    }
}

// Funktion zum resamplen !
function CreateAvatar($size, $source, $dest, $border = 0)
{
    $sourcedate = 0;
    $destdate = 0;
    $piqualitaet = 100;
    $gdversion = 2;
    if (file_exists($dest)) {
        clearstatcache();
        $sourceinfo = stat($source);
        $destinfo = stat($dest);
        $sourcedate = $sourceinfo[10];
        $destdate = $destinfo[10];
    }
    if (!file_exists("$dest") or ($sourcedate > $destdate)) {
        $imgsize = GetImageSize($source);
        $width = $imgsize[0];
        $height = $imgsize[1];
        $new_width = $size;
        $new_height = ceil($size * $height / $width);
        switch ($imgsize[2]):
            case 1 : $im = ImageCreateFromGIF($source);
                break;
            case 2 : $im = ImageCreateFromJPEG($source);
                break;
            case 3 : $im = ImageCreateFromPNG($source);
                break;
                endswitch;
                if ($gdversion == 2) {
                    $new_im = imagecreatetruecolor($new_width, $new_height);
                    imagecopyresampled($new_im, $im, 0, 0, 0, 0, $new_width, $new_height, ImageSX($im), ImageSY($im));
                } else {
                    $new_im = ImageCreate($new_width, $new_height);
                    ImageCopyResized($new_im, $im, 0, 0, 0, 0, $new_width, $new_height, ImageSX($im), ImageSY($im));
                }
                ImageJPEG($new_im, $dest, $piqualitaet);
        }
    }

    function search_highlight($text)
    {
        $highlight = urldecode($_GET['highlight']);
        $highlight = explode(' ', $highlight);
        foreach ($highlight as $word) {
            if (!empty($word)) {
                $text = preg_replace('!(' . $word . ')!i', '<span class="highlight">\1</span>', $text);
            }
        }
        return $text;
    }

function pfCatPfadLink($id)    {
	global $serverid, $tab_pfilescat, $tab_pfiles;
	$pfad = "";
	$catid = $id;
	while ($catid != 0) {
	    $sqlbefehl = "Select subcat,name,id FROM $tab_pfilescat where id='$catid'";
	    $getsubcat = mysql_query($sqlbefehl, $serverid);
	    $subcat = mysql_fetch_array ($getsubcat);
	    $catid = $subcat[subcat];
	    $pfad = " / <a href=\"index.php?showcat=$subcat[id]\">$subcat[name]</a>" . $pfad;
	}
	$pfad = "<a href=\"index.php?showcat=0\">".LanguageTag('PLhome')."</a>" . $pfad;
	return $pfad;
}

function pfUpdateCatPfad($id) {
    global $serverid, $tab_pfilescat, $tab_pfiles;
    $pfad = "";
    $catid = $id;
    while ($catid != 0) {
        $sqlbefehl = "Select subcat,name,id FROM $tab_pfilescat where id='$catid'";
        $getsubcat = mysql_query($sqlbefehl, $serverid);
        $subcat = mysql_fetch_array ($getsubcat);
        $catid = $subcat[subcat];
        $pfad = " / $subcat[name]" . $pfad;
    }
    $pfad = LanguageTag('PLhome') . $pfad;
    $pfad = addslashes($pfad);
    $sqlbefehl = "update $tab_pfilescat set
                 pfad='$pfad'
                 where id='$id'";
    if (!$ergebnis = mysql_query($sqlbefehl, $serverid))
    	echo mysql_error($serverid);
}

    function formatFileInfo($info)
    {
        $info = nl2br($info);
        return $info;
    }
    // Newsletter Body modifizieren
    function LetterBody($body, $format)
    {
        GLOBAL $pset, $purl;
        if ($format == "text/html") {
            $body = stripslashes($body);
            $body = $body . "<br><br>$pset[systitle] Newsletter: Wenn sie diesen Newsletter nicht mehr erhalten möchten: $purl/newsletter.php";
        } else {
            $body = str_replace("\r", "", $body);
            $body = stripslashes($body);
            $body = $body . "\n\n$pset[systitle] Newsletter: Wenn sie diesen Newsletter nicht mehr erhalten möchten: $purl/newsletter.php";
        }
        return $body;
    }

// Userliste Online anzeigen
function ShowUsers()
    {
        global $serverid , $purl, $tab_user, $purl_user, $user, $tab_glog,$userbuddylist;
        $jetzt = time();
        $sqlbefehl = "Select id,nickname,usertyp
                 From $tab_user where expire > UNIX_TIMESTAMP()
                               And invisible=0
                 order by usertyp,nickname";
        $getuser = mysql_query($sqlbefehl, $serverid);
        echo "<table width=\"100%\" class=\"panel\" cellspacing=\"1\" cellpadding=\"1\" border=\"0\">
          <tr><th class=\"head\"><font size=\"1\">Benutzer Online</font></th></tr>
          <tr><td class=\"left\" align=\"center\"><font size=\"1\">";
        if (mysql_num_rows($getuser) == 0) {
            echo "keine Benutzer online";
        }
        $userlist = '';
        while ($userl = mysql_fetch_array($getuser)) {
            $userlist = $userlist . "<nobr>";
            if ($userl[usertyp] == "admin") $userlist = $userlist . "<b>";
            if ($userl[usertyp] == "moderate") $userlist = $userlist . "<i>";
            if ($user['id'] == $userl['id']) {
                $userlist = $userlist . "<a href=\"$purl_user/edituser.php?id=$userl[id]\">" . stripslashes($userl[nickname]) . "</a>";
            } else {
                $userlist = $userlist . "<a href=\"$purl_user/showprofil.php?id=$userl[id]\">" . stripslashes($userl[nickname]) . "</a>";
            }
            if ( psys_inbuddylist($userl['id']) ) {
            	$userlist = $userlist ."+";
            }
            if ($userl[usertyp] == "admin") $userlist = $userlist . "</b>";
            if ($userl[usertyp] == "moderate") $userlist = $userlist . "</i>";
            $userlist = $userlist . "</nobr>, ";
        }
        $userlist = substr($userlist, 0, (strlen($userlist)-2));
        echo $userlist;
        // Gäste
        $resultlogtab = mysql_query("SELECT Count(*) as total FROM $tab_glog");
		$numberlogtab = mysql_fetch_array($resultlogtab);
		$guestonline = $numberlogtab['total'];
		if ( $guestonline > 0 ) {
			echo "<tr><td class=\"right\" align=\"center\"><font size=\"1\">Gäste: $guestonline</font></td></tr>";
		}
        echo "</td></tr></table>";
} //End ShowForumUser

// #################### Funktionen zum Checken der Zugriffsrechte : ################
// #################### Änderungen können die Sicherheit des Boardes beeinträchtigen !
function getrights($boardid, $boardtyp)
{
    global $user_typ, $user;
    global $user_id;
    global $serverid, $pdb;
    global $tab_acc, $tab_usergrp, $tab_grpacc;
    global $pf_cache_rights;

    $rights = "no";

    if (isset($_SESSION['s_boardright']) and $pf_cache_rights == 0) {
        unset($_SESSION['s_boardright']);
    }
    // ###### Admin erhält immer volle Rechte !
    if ($user_typ == "admin" or $user_typ == "moderate") {
        $rights = "moderate";
    }
    if ($user_typ == "lock") {
        $user_typ = "guest";
    }

    if ($_SESSION['s_boardright'][$boardid] == "" or $pf_cache_rights == 0) {
        // Rechte aus der DB auslesen
        if ($user_typ == "guest") {
            // Standard Gäste Rechte
            if ($boardtyp == "GuestS") {
                $rights = "write";
            } elseif ($boardtyp == "GuestR") {
                $rights = "reply";
            } elseif ($boardtyp == "GuestL") {
                $rights = "read";
            } elseif ($boardtyp == "ReadOnly") {
                $rights = "read";
            } elseif ($boardtyp == "Reply") {
                $rights = "reply";
            } elseif ($boardtyp == "UserM") {
                $rights = "write";
            } else {
                $rights = "no";
            }
        }
        if ($user_typ == "user") {
            // Standard User Rechte
            if ($boardtyp == "UserS") {
                $rights = "write";
            } elseif ($boardtyp == "UserR") {
                $rights = "reply";
            } elseif ($boardtyp == "UserL") {
                $rights = "read";
            } elseif ($boardtyp == "GuestS") {
                $rights = "write";
            } elseif ($boardtyp == "GuestL") {
                $rights = "write";
            } elseif ($boardtyp == "GuestR") {
                $rights = "write";
            } elseif ($boardtyp == "Reply") {
                $rights = "reply";
            } elseif ($boardtyp == "UserM") {
                $rights = "moderate";
            } elseif ($boardtyp == "ReadOnly") {
                $rights = "read";
            } elseif ($boardtyp == "Ticket") {
                $rights = "write";
            } else {
                $rights = "no";
            }
        }
        if ($user_typ != "guest") {
            // neue Gruppenrechte nach Level auslesen :
            $sqlbefehl = "Select Max(a.intlevel) As lev From $tab_grpacc a
        	         Left Join $tab_usergrp u on u.grpid=a.grpid
                     Where a.boardid='$boardid' and u.userid='$user_id'";
            $getlevel = mysql_query($sqlbefehl, $serverid);
            $level = mysql_fetch_array($getlevel);
            if ($level['lev'] == 10) {
                $rights = 'no';
            }
            if ($level['lev'] == 20) {
                $rights = 'read';
            }
            if ($level['lev'] == 30) {
                $rights = 'reply';
            }
            if ($level['lev'] == 40) {
                $rights = 'write';
            }
            if ($level['lev'] == 50) {
                $rights = 'moderate';
            }
            // ################## wenn ein Private Board , so werden die Rechte aus der DB gelesen !
            // ################## und die globalen Boardrechte überschrieben !
            $sqlbefehl = "Select level FROM $tab_acc where boardid='$boardid' and userid='$user_id'";
            $getlevel = mysql_query($sqlbefehl, $serverid);
            $level = mysql_fetch_array($getlevel);
            if (trim($level['level']) != "") {
                $rights = $level['level'];
            }
        }
        if ($pf_cache_rights == 1) {
            $_SESSION['s_boardright'][$boardid] = $rights;
        }
    } else {
        //gemerktes Boardrecht übernehmen
        $rights = $_SESSION['s_boardright'][$boardid];
    }
    if ($user['lockdown'] > time() and $rights != "no") {
        //Geknebelte User dürfen nur lesen !
        $rights = "read";
    }
    return $rights;
}

// Content Output
/*
function p_include_string ( $code ) {
    global $pdir_cache;
    $file = tempnam($pdir_cache,'pis').".php";
    file_put_contents($file,$code);
    include($file);
    unlink($file);
    //echo $file;
}
*/

function contentoutput ($id)
    {
        global $serverid, $tab_content, $user;
        $id=intval($id);
        $sqlbefehl = "Select * From $tab_content Where id = '$id' ";
        $getcont = mysql_query($sqlbefehl, $serverid);
        $cont = mysql_fetch_array($getcont);
        if ($cont['status'] != "frei") {
            // msgbox("$coID ist gesperrt");
        } else {
            if ($cont['typ'] == 'html') {
                echo stripslashes($cont['content']);
            } elseif ($cont['typ'] == 'text') {
                echo formatpost($cont['content']);
            } elseif ($cont['typ'] == 'php') {
                // p_include_string($cont['content']);
                eval(" ?> " . $cont['content'] . " <?php ");
            } elseif ($cont['typ'] == 'iframe') {
                // p_include_string($cont['content']);
                echo "<iframe class=\"content\" src=\"$cont[content]\"></iframe>";
            } else {
                msgbox("$coID Content Typ Fehler");
            }
        }
    }

function poutNumber($var)
{
	return number_format($var,0,',','.');
}

//entfernt URLs aus einem String
function strip_urls($str) {
    $urlSA = array('#([^]_a-z0-9-="\'/])((https?|ut2004|ut2003|teamspeak|ed2k|unreal|ftp|gopher|news|telnet)://|www\.)([^ \r\n\(\)\*\^\$!`"\'\|\[\]\{\}<>]*)#si',
        '#^((https?|ut2004|ut2003|teamspeak|ed2k|unreal|ftp|gopher|news|telnet)://|www\.)([^ \r\n\(\)\*\^\$!`"\'\|\[\]\{\}<>]*)#si'
        );
	return preg_replace($urlSA, "", $str);
}

function psys_language($file,$prefix = "PSL_"){
	if ( $arr = @parse_ini_file($file) ) {
		foreach($arr as $tag => $var ) {
			$c = "$prefix"."$tag";
			//echo $c;
			if ( !defined( $c )) {
				define($c, $var);
			}
		}
	} else {
		echo "Error Parsing Language File $file";
	}
}

function psys_createpass(){
	srand((double)microtime() * 1000000);
    $newpass = md5(uniqid(rand()));
    return substr($newpass, 0, 8);
}

function psys_postpage($eintrag, $proseite = 20 ) {
	//ermitteln die Seite auf der sich ein Post befindet
	$seite = $eintrag / $proseite;
	$seite = floor($seite);
	$seite = $seite * $proseite;
	return $seite;
}

//Formular Cache - holt aus dem Request eine Variable und cached diese in der
//Session bis sie wieder neu requestiert wird.
function psys_fcache($var, $default = '') {
	if ( isset($_REQUEST[$var]) ) {
		if ( $_REQUEST[$var] == "" ) {
		    unset($_SESSION['fcache'][$var]);
		} else {
			$_SESSION['fcache'][$var] = $_REQUEST[$var];
		}
	}
	if ( isset($_SESSION['fcache'][$var]) ) {
		return $_SESSION['fcache'][$var];
	} else {
		if ( $default == '') {
			//return false;
		} else {
			return $default;
		}
	}
}

function LanguageTag($tag)
{
	GLOBAL $tab_langdb;
	$locale = PSL_localtag;
	$getds = mysql_query("Select tag,word From $tab_langdb Where locale='$locale' and tag ='$tag' ");
	if ( mysql_num_rows($getds) == 0 ) {
		@mysql_query("Insert Into $tab_langdb (tag,locale) values('$tag','$locale')");
		$tag['word']=$tag;
		return $tag;
	} else {
		$dbtag = mysql_fetch_array($getds);
		if ($dbtag['word'] != "") {
		    return $dbtag['word'];
		} else {
		    return $tag;
        }
	}
}

function pagetitle_assign($title) {
    global $pagetitle,$pset;
    if ( $pagetitle == "") {
        $pagetitle = $pset['systitel'];
    }
    if ( trim($title) != "" ) {
        $pagetitle.=" - ".$title;
    }
}

function parseURI() {
    $uri = $_SERVER['REQUEST_URI'];
    if (!strstr($uri,$_SERVER['SCRIPT_NAME']) )
        return false;
    $scriptname = addcslashes($_SERVER['SCRIPT_NAME'],'./');
    $uri = preg_replace('/.*?'.$scriptname.'(\/|)/','',$uri);
    if (trim($uri) != "") {
        $request = explode("/",$uri);
        $count = count($request);
        for ($i = 0 ; $i < $count ; $i++) {
            $values["arg".$i] = $request[$i];
        }
        return $values;
    } else {
        return false;
    }
}

function ReCaptchaCheck(){
	global $popt;
	if ($_POST["recaptcha_response_field"]) {
		$resp = recaptcha_check_answer ($popt->opt['recaptcha_privatekey'],
		                                $_SERVER["REMOTE_ADDR"],
		                                $_POST["recaptcha_challenge_field"],
		                                $_POST["recaptcha_response_field"]);
		if ($resp->is_valid) {
			//echo "You got it!";
			$_SESSION['recaptcha_valid'] = TRUE;
			return TRUE;
		} else {
			# set the error code so that we can display it
			return $resp->error;
		}
	} else {
		return FALSE;
	}
}
?>