<?php
//##############################################################################
//## PSCRIPT Shop Funktionen                                                  ##
//##############################################################################
// 16.05.2003 - Pageswitcher gefixed
// 31.01.2004 - PSCatPfad
// 06.05.2004 - Lagerbestands-Ampelanzeige
// 17.06.2005 - PSCatPfadLink
//##############################################################################

if (!function_exists('PSLagerInfo')) {
	//Lagerinfo - Pic anzeigen abhängig von Menge / Mindestmenge
	function PSLagerinfo($menge,$minmenge) {
	    if ( $minmenge > 0 ) {
			if ( $menge <= 0 ) {
			    $picn = 4;
			}
			if ( $menge > 0 and $menge <= ( $minmenge / 2 ) ) {
			    $picn = 3;
			}
			if ( $menge <= $minmenge and ( $menge > ( $minmenge / 2)) ) {
			    $picn = 2;
			}
			if ( $menge >   $minmenge ) {
			    $picn = 1;
			}
			if ( $menge > ( $minmenge*2) ) 	{
				$picn = 0;
			}
	    }
	    else {
	        $picn = 0;
	    }
		return "<img src=\"image/lager_$picn.gif\" align=\"absmiddle\" />";
	}
}

if (!function_exists('PSCatPfad')) {
	function PSCatPfad($catid) {
	    global $serverid, $tab_scat;
	    $pfad="";
	    while ( $catid != 0) {
	        $sqlbefehl= "Select subcat,name,id FROM $tab_scat where id='$catid'";
	        $getsubcat  = mysql_query($sqlbefehl, $serverid);
	        $subcat = mysql_fetch_array ($getsubcat);
	        $catid=$subcat[subcat];
	        $pfad= " / $subcat[name]".$pfad;
	    }
	    $pfad= "Übersicht".$pfad;
	    return $pfad;
	}
}

if (!function_exists('PSCatPfadLink')) {
	function PSCatPfadLink($catid) {
	    global $serverid, $tab_scat;
	    $pfad="";
	    while ( $catid != 0) {
	        $sqlbefehl= "Select subcat,name,id FROM $tab_scat where id='$catid'";
	        $getsubcat  = mysql_query($sqlbefehl, $serverid);
	        $subcat = mysql_fetch_array ($getsubcat);
	        $catid=$subcat[subcat];
	        $pfad= " / <a href=\"index.php?showcat=$subcat[id]\">$subcat[name]</a>".$pfad;
	    }
	    $pfad= "<a href=\"index.php?showcat=0\">Übersicht</a>".$pfad;
	    return $pfad;
	}
}

if (!function_exists('PSUpdateCatPfad')) {
    function PSUpdateCatPfad($id)
    {
        global $serverid,$tab_scat;
        $pfad=PSCatPfad($id);
        $pfad= addslashes($pfad);
        $sqlbefehl  =  "update $tab_scat set
                         pfad='$pfad'
                         where id='$id'";
        if (!$ergebnis  = mysql_query($sqlbefehl, $serverid))
        echo mysql_error($serverid);
    }
}

function ShopWaehrungFormat($preis)
{
	global $shopwaehrung;
	return number_format($preis,2,',','.')." $shopwaehrung";
}

if (!function_exists('ShopCreateImage')) {
function ShopCreateImage($size,$source,$dest,$border=0) {
   $sourcedate = 0;
   $destdate = 0;
   global $convert;
   global $piqualitaet;
   global $pigdversion;
   if (file_exists($dest)) {
      clearstatcache();
      $sourceinfo = stat($source);
      $destinfo = stat($dest);
      $sourcedate = $sourceinfo[10];
      $destdate = $destinfo[10];
   }
   if (!file_exists("$dest") or ($sourcedate > $destdate)) {
      global $ImageTool;
      $imgsize = GetImageSize($source);
      $width = $imgsize[0];
      $height = $imgsize[1];

      $new_width = $size;
      $new_height = ceil($size * $height / $width);
		//Wenn es höher wird
	  	if( $new_height > $size ) {
	  	    $new_height = $size;
	  	    $new_width  = ceil(($size * $width) / $height );
      	}

      switch($imgsize[2]):
       case 1 : $im = ImageCreateFromGIF($source);
      break;
       case 2 : $im = ImageCreateFromJPEG($source);
      break;
       case 3 : $im = ImageCreateFromPNG($source);
      break;
      endswitch;

      if ($pigdversion ==2 ) {
             $new_im = imagecreatetruecolor($new_width,$new_height);
             imagecopyresampled($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));
      }
      else { $new_im = ImageCreate($new_width,$new_height);
             ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));
      }
      ImageJPEG($new_im,$dest,$piqualitaet);
   }
}
}

function pShopImage($id,$image){
    global $psdir_org, $psdir_zoom, $psurl_zoom,$zoom_size,$thumb_border;
    //Image
    $sourcefile= $psdir_org."/".$image;
    if (file_exists("$sourcefile") and $image != "") {
        $zoomfile = $psdir_zoom."/".$id.".jpg";
        if (!file_exists("$zoomfile")) {
            ShopCreateImage($zoom_size,$sourcefile,$zoomfile,$thumb_border);
        }
        return $psurl_zoom."/$id.jpg";
    } else {
        return false;
    }
}

function pShopPreviewImage($id,$image){
	global $psdir_org, $psdir_zoom, $psurl_zoom,$thumb_size,$thumb_border;
	//Image
	$sourcefile= $psdir_org."/".$image;
	if (file_exists("$sourcefile") and $image != "") {
		$zoomfile = $psdir_zoom."/preview_".$id.".jpg";
		if (!file_exists("$zoomfile")) {
			ShopCreateImage($thumb_size,$sourcefile,$zoomfile,$thumb_border);
		}
		return $psurl_zoom."/preview_$id.jpg";
	} else {
		return false;
	}
}
?>