<?php
// ##############################################################################
// ## PFORUM Avatar Upload                                                     ##
// ##############################################################################
// 21.10.2004 - $pf_avatar_resample in Benutzung
// ##############################################################################
require("puser_main.php");

if ($user_id == 0) {
    header ("Location: index.php");
    exit;
}

require("../kopf.php");
include("head.php");
// Rechte checken
if (!is_writeable($pdir_avataruser)) {
    msgbox("/media/avataruser is not writeable!");
    require("../fuss.php");
    exit();
}

// Check auf GD
if (!extension_loaded("gd")) {
    msgBox(LanguageTag('PLERRORno_gd_lib'));
    require("../fuss.php");
    exit();
}

if ($avatar_upload != 1) {
    msgBox(LanguageTag('PLERRORno_avatar_upload'));
    require("../fuss.php");
    exit();
}

$avatardir = $pdir_avataruser; //Dateiverzeichniss
$kbyte = $avatar_size / 1024; //Umrechnung in Kb zur besseren Darstellung (!nicht ndern!)

unset($bild);
$bild[0] = "gif";
$bild[1] = "jpg";
$bild[2] = "png";
$groese = "";
$error = 0;

if (isset($_POST['upload'])) {
    // error1
    if ($_FILES['file']['name'] == "") {
        $error = 1;
        msgBox(LanguageTag('PLMSGno_file_selected'));
    }
    // error2
    if ($_FILES['file']['size'] > $avatar_size) {
        $error = 1;
        msgBox(LanguageTag('PLMSGfile_to_big'));
    }
    // error3
    if ($_FILES['file']['tmp_name'] != "") {
        $groese = getimagesize($_FILES['file']['tmp_name']);
        if ($groese[2] == "") {
            $error = 1;
            msgBox(LanguageTag('PLMSGfiletyp_not_allowed'));
        }
    }

    if ($groese[2] == "") {
        $error = 1;
        msgBox(LanguageTag('PLMSGimage_dimension_to_big'));
    }

    if ($groese[0] > $avatar_width || $groese[1] > $avatar_height) {
        $error = 1;
        msgBox(LanguageTag('PLMSGfiletyp_not_allowed'));
    }

    $filename = "avatar_" . $user_id . ".jpg";

    if ($error == 0) {
        // alten Avatar lschen.....
        $fp = opendir($avatardir);
        while ($datei = readdir($fp)) {
            if (strstr($datei, "avatar_$user_id")) {
                for($i = 0; $i < 3; $i++):
                @unlink($avatardir . "/avatar_" . $user_id . "." . $bild[$i]);
                endfor;
            }
        }
        // @move_uploaded_file($file, "$avatardir/$filename") or die("Fehler !!! Der Avatar kann nicht in das Verzeichnis kopiert werden !<br>");
        // @copy($file, "$avatardir/$filename") or die("Fehler !!! Der Avatar kann nicht in das Verzeichnis kopiert werden !<br>");
        $sourcefile = $_FILES['file']['tmp_name'];
        $destfile = "$avatardir/$filename";
        if ($pf_avatar_resample == 1) {
            CreateAvatar($groese[0], $sourcefile, $destfile, 0) ;
        } else {
            copy($sourcefile, $destfile);
        }
        $smarty_user->assign('filename', $filename);
        $smarty_user->assign('purl_avataruser', $purl_avataruser);
        $smarty_user->display('user_uploadavatar_check.tpl');
    }
}

$smarty_user->assign('kbyte', $kbyte);
$smarty_user->assign('bild', $bild);
$smarty_user->assign('avatar_width', $avatar_width);
$smarty_user->assign('avatar_height', $avatar_height);
$smarty_user->display('user_uploadavatar.tpl');
require("../fuss.php");

?>