<?php
//##############################################################################
//## PFORUM - Admin Index                                                     ##
//##############################################################################
// 21.01.2002 - FavBoard und FavThread Fix
// 15.12.2002 - Anpassungen fr User/Gruppen
// 13.04.2004 - Ungelinkte Favoriten/User trennen
// 15.11.2004 - Files
//##############################################################################

require("pforum_main.php");
$pagetitle.=" - Admin";
require($pdir_admin."/kopf.php");
require("adminkopf.inc.php");

if ($user_typ != "admin") {
    msgbox(LanguageTag('PLnoaccess'));
    include($pdir_admin."/fuss.php");
    exit();
}
$smarty_forum->caching = 2;
$smarty_forum->cache_lifetime = 2476;
if (!$smarty_forum->is_cached('forum_admin.tpl'))  {

    //############## Anzahl Boards###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_board");
    $stat['boardcount'] = $anzahl['total'];

    //############## Anzahl User ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_user");
    $stat['usercount'] = $anzahl['total'];

    //############## Anzahl Threads ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_thread");
    $stat['threadcount'] = $anzahl['total'];

    //############## Anzahl Posts ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_post");
    $stat['postcount'] = $anzahl['total'];

    //############## Anzahl PMs ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_pm");
    $stat['pmcount'] = $anzahl['total'];

    //############## Files  ###############
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_fileinfo");
    $stat['filecount'] = $anzahl['total'];

    // Avatare ############################
    clearstatcache();
    $fp=opendir($pdir_avataruser);
    while ($datei = readdir($fp)) {
      	if (is_file("$pdir_avataruser/$datei")) {
       		$files = $files +1;
      	}
    }
    closedir($fp);
    $stat['avatarcount'] = $files;
    $smarty_forum->assign('stat',$stat);
}
$smarty_forum->display('forum_admin.tpl');
$smarty_forum->caching = 0;
require($pdir_admin."/fuss.php");
?>