<?php
//##############################################################################
//## pFORUM - Board                                                           ##
//## Thomas Ehrhardt                                                          ##
//## www.powie.de                                                             ##
//##############################################################################
// 02.03.2002 - Zum Lastact hinzugefgt
// 15.04.2002 - Legende eingefgt.
// 13.01.2004 - Neue Boardinfos markieren
// 27.02.2004 - pfshortpost - title
// 10.11.2004 - Files
// 14.11.2005 - Ticket Typ
//##############################################################################

require("pforum_main.php");

$id  =  intval($_REQUEST['id']);
$boardid=$id;
if ($id == 0) {
	//wir bentigen IMMER eine Board ID
    header ("Location: index.php");
    exit;
}
$eintrag=intval($_REQUEST['eintrag']);

//Board auslesen
$board=$pdb->RowByID($tab_board,$id);
if ( $board['id'] == 0) {
    header ("Location: index.php");
    exit();
}

//Kategorie
$cat=$pdb->RowByID($tab_cat,$board['catid']);

pagetitle_assign($board['name']);
include('ajax_newpost.inc.php');
require("../kopf.php");
include("head.php");

$rights=getrights($board['id'],$board['boardtyp']);
if ($rights == "no") {
    msgbox(LanguageTag('PLnoaccess'));
    require($pdir."/fuss.php");
	exit();
}

//Count Threads
$sqlbefehl= "Select count(*) as total FROM $tab_thread where boardid='$id'";
$getthread  = mysql_query($sqlbefehl, $serverid);
$anzahl= mysql_fetch_array($getthread);
$count['threads'] = $anzahl['total'];

//Moderatoren anzeigen
$sqlbefehl = "Select u.id,u.nickname From $tab_user u
              Left Join $tab_acc a on a.userid=u.id
              Where a.boardid = '$id' and a.level ='moderate'";
$smarty_forum->assign('smoduser',$pdb->fetch_array($sqlbefehl));
//Mod Gruppe
$sqlbefehl= "Select g.id,g.name From $tab_group g
             Left Join $tab_grpacc a on a.grpid=g.id
             Where a.intlevel=50 and a.boardid='$id'
             Group by g.id";
$smarty_forum->assign('smodgroup',$pdb->fetch_array($sqlbefehl));

//User im Board ##############################################
if ($user_id != 0) {
    $pdb->query("Update $tab_user set inboard='$boardid' Where id = '$user_id'");
}
$sqlbefehl= "Select id,nickname
             From $tab_user
             Where inboard = '$boardid' And invisible=0
			 and id != '$user_id' and expire != 0";
$smarty_forum->assign('sboarduser',$pdb->fetch_array($sqlbefehl));

//Boardinfo und Topthreads nur auf Seite 1 anzeigen #########################
if ( $eintrag == 0 ) {
	//Boardinfo anzeigen ############################
	$sqlbefehl= "Select i.* , u.id as userid, u.nickname as nickname
                 FROM $tab_info i
                 Left Outer Join $tab_user u on u.id=i.userid
                 where i.boardid='$id' or i.catid='$board[catid]'
                       or i.boardid=0
                 order by i.time desc ";
	$smarty_forum->assign('sboardinfo',$pdb->fetch_array($sqlbefehl));

    //Top Threads #####################################
    $sqlbefehl= "Select t.*,l.nickname as lastusernickname FROM $tab_thread t
             Left Outer Join $tab_user l on l.id=t.lastuserid
             Where t.boardid= '$id' and t.status='top'
             order by t.time desc";
    $smarty_forum->assign('stopthreads',$pdb->fetch_array($sqlbefehl));
}


//Threads #########################################
//User Filter fr TicketBoard
if ( $board['boardtyp'] == 'Ticket' and $rights == 'write' ) {
	$filteruser = " And t.userid = '$user_id' ";
} else {
    $filteruser = "";
}
$sqlbefehl= "Select t.* ,l.nickname as lastusernickname
             FROM $tab_thread t
             Left Outer Join $tab_user l on l.id=t.lastuserid
             Where t.boardid= '$id' and t.status != 'top' $filteruser
             order by t.time desc LIMIT $eintrag,$zps";
$getthread  = mysql_query($sqlbefehl, $serverid);
while ( $thread = mysql_fetch_array($getthread)) {
	$thread['iconurl'] = getTicon($thread['icon']);
	if ($user['forum_lastlogin'] < $thread[time] and $_SESSION['s_readthread'][$thread[id]] < $thread[time]) {
	    $thread['flag_new'] = true;
	    $b_newthreads = 1;
	}
	if ($thread['postcount'] > $zps) {
	    $thread['pager'] = pageswitcher(0,$zps,$thread['postcount'],"showthread.php?id=$thread[id]&eintrag");
	}
	$thread['rating'] = getThreadRating($thread);
	$st[] = $thread;
}
$smarty_forum->assign('sthreads',$st);

//gelesen markieren
if( $b_newthreads != 1 and $eintragaktuell == 0 ) {
   $_SESSION['s_readboard'][$id] = time();
   pfread_save();
}

//Pager
$counter = mysql_query("SELECT Count(*) as total FROM $tab_thread where boardid='$id' and status <> 'top'");
$eintraege = mysql_fetch_array($counter);
$smarty_forum->assign('pager',pageswitcher($eintrag,$zps,$eintraege['total'],"showboard.php?id=$id&eintrag"));


//######################### Moderation #########################################
if ($rights == "moderate") {
    $smarty_forum->assign('flag_moderate',true);
}

//################ Add Favorit #################################################
$sqlbefehl =  "select id from $tab_fav
               where userid=$user_id and typ='board' and favid=$id";
$getid  = mysql_query($sqlbefehl, $serverid);
if ($user_typ != "guest" and mysql_num_rows($getid) ==0) {
    $smarty_forum->assign('flag_addfav',true);
}

$smarty_forum->assign('board',$board);
$smarty_forum->assign('cat',$cat);
$smarty_forum->assign('count',$count);
$smarty_forum->assign('eintrag',$eintrag);
$smarty_forum->assign('threadhot',$threadhot);
$smarty_forum->assign('rights',$rights);
$smarty_forum->display('forum_board.tpl');

// ######################## Legende ############################################
require("legende.php");
// #############################################################################
$newthread="true";
$boardid=$id;
if ($rights == "write" or $rights=="moderate") {
   require("newpost.inc.php");
}
// ###################### Forum Jump ! #######################
require("forumjump.php");
//###################### Fuss ###########################
require($pdir."/fuss.php");
pforum_logintime();
?>