<?php
//##############################################################################
//## pHRCEditor                                                               ##
//## Thomas Ehrhardt                                                          ##
//## www.powie.de                                                             ##
//##############################################################################

//V1
class pHRCedit
{
	var $InstanceName ;
	var $BasePath ;
	var $Width ;
	var $Height ;
	var $Value ;

	// PHP 5 Constructor
	function __construct( $instanceName )
 	{
		$this->InstanceName	= $instanceName ;
		$this->BasePath		= '/cms/lib/' ;
		$this->Width		= '100%' ;
		$this->Height		= '300' ;
		$this->Value		= '' ;
	}

	// PHP 4 Contructor
	function pHRCedit( $instanceName )
	{
		$this->__construct( $instanceName ) ;
	}

	function Create()
	{
		echo $this->CreateHtml() ;
	}
	function CreateHtml()
	{
		$html = "<table style=\"width:{$this->Width}; height:{$this->Height};\" class=\"no\"><tr><td>";
		$html.= "<script type=\"text/javascript\" src=\"{$this->BasePath}/hrccodes.js\"></script>";
		$html.= "Schriftfarbe: <select name=\"colour\" onChange=\"AddToField(this.form.{$this->InstanceName},'[color=' + this.form.colour.options[this.form.colour.selectedIndex].value + ']' + 'Farbtext[/color]')\">
					<option value=\"\">-</option>
					<option style=\"color:black; background-color: #CCCCCC\" value=\"black\">Schwarz</option>
					<option style=\"color:darkred; background-color: #CCCCCC\" value=\"darkred\">Dunkelrot</option>
					<option style=\"color:red; background-color: #CCCCCC\" value=\"red\">Rot</option>
					<option style=\"color:orange; background-color: #CCCCCC\" value=\"orange\">Orange</option>
					<option style=\"color:brown; background-color: #CCCCCC\" value=\"brown\">Braun</option>
					<option style=\"color:yellow; background-color: #CCCCCC\" value=\"yellow\">Gelb</option>
					<option style=\"color:green; background-color: #CCCCCC\" value=\"green\">Grün</option>
					<option style=\"color:olive; background-color: #CCCCCC\" value=\"olive\">Olive</option>
					<option style=\"color:cyan; background-color: #CCCCCC\" value=\"cyan\">Türkis</option>
					<option style=\"color:blue; background-color: #CCCCCC\" value=\"blue\">Blau</option>
					<option style=\"color:darkblue; background-color: #CCCCCC\" value=\"darkblue\">Dunkelblau</option>
					<option style=\"color:indigo; background-color: #CCCCCC\" value=\"indigo\">Indigo</option>
					<option style=\"color:violet; background-color: #CCCCCC\" value=\"violet\">Violett</option>
					</select>
					&#160; Schriftgröße:
					<select name=\"sizer\" onChange=\"AddToField(this.form.{$this->InstanceName},'[size=' + this.form.sizer.options[this.form.sizer.selectedIndex].value + ']' + 'Textgröße' + this.form.sizer.options[this.form.sizer.selectedIndex].value + '[/size]')\">
					<option value=\"\">-</option>
					<option value=\"8px\">8 Pixel</option>
					<option value=\"10px\">10 Pixel</option>
					<option value=\"12px\">12 Pixel</option>
					<option value=\"14px\">14 Pixel</option>
					<option value=\"16px\">16 Pixel</option>
					<option value=\"20px\">20 Pixel</option>
					</select></td></tr><tr><td>";
		$html.= "<textarea id=\"{$this->InstanceName}\" name=\"{$this->InstanceName}\" style=\"width:{$this->Width}; height:{$this->Height};\"
		          ONSELECT=\"storeCaret(this);\" ONCLICK=\"storeCaret(this);\" ONKEYUP=\"storeCaret(this);\"
		          rows=\"12\" cols=\"40\" wrap=\"virtual\">";
		$html.= htmlspecialchars($this->Value);
		$html.= "</textarea></td></tr><tr><td>";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrcline(this.form.{$this->InstanceName});\" value=\"Trennlinie\">";
		$html.=	"<input type=\"button\" style='font-size:10px' onClick=\"hrcbold(this.form.{$this->InstanceName})\" value=\"Fett\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrcitalic(this.form.{$this->InstanceName})\" value=\"Kursiv\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrcunderlined(this.form.{$this->InstanceName})\" value=\"Unterstrichen\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrcimg(this.form.{$this->InstanceName})\" value=\"Bild\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrclink(this.form.{$this->InstanceName})\" value=\"Link\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrcemail(this.form.{$this->InstanceName})\" value=\"Email\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrccenter(this.form.{$this->InstanceName})\" value=\"zentriert\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrccode(this.form.{$this->InstanceName})\" value=\"Code\">";
		$html.= "<input type=\"button\" style='font-size:10px' onClick=\"hrcquote(this.form.{$this->InstanceName})\" value=\"Zitat\">";
		$html.= "</td></tr></table>";
		return $html;
	}
}

//V2
class pHRCedit2
{
	var $InstanceName ;
	var $ImagePath ;
	var $Width ;
	var $Height ;
	var $Value ;

	// PHP 5 Constructor
	function __construct( $instanceName )
 	{
		$this->InstanceName	= $instanceName ;
		$this->ImagePath	= '/cms/images/editor' ;
		$this->Width		= '100%' ;
		$this->Height		= '300' ;
		$this->Value		= '' ;
	}

	// PHP 4 Contructor
	function pHRCedit2( $instanceName )
	{
		$this->__construct( $instanceName ) ;
	}

	function Create()
	{
		echo $this->CreateHtml() ;
	}
	function CreateHtml()
	{
		$html = "<!-- phrc2 editor begin -->
				<style type=\"text/css\">
                .editbutton {
                    border-width:0px;
                    margin:1px;
                    padding:0px;
                    border-style:none;
                }
                .editraise {
                    border-width:1px;
                    margin:0px;
                    padding:0px;
                    border-style:solid;
                    border-color:black;
                    background-color:white;
                }
                .editpress{
                    border-width:1px;
                    margin:0px;
                    padding:0px;
                    border-style:solid;
                    border-color:black;
                    background-color:red;
                }
                </style>
				<table class=\"no\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" style=\"width:{$this->Width}; height:{$this->Height};\" >
    				<tr>
        				<td style=\"background-image:url({$this->ImagePath}/toolbar_bg.gif);\"  valign=\"baseline\">
							<table class=\"no\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">
								<tr>
									<td><img src=\"{$this->ImagePath}/toolbar_start.gif\" border=\"0\"></td>
									<td><img class=\"editbutton\" onclick=\"phrc(hrcbold);\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
									     	 src=\"{$this->ImagePath}/button_bold.gif\" border=\"0\" title=\"Fett\"></td>
				            		<td><img class=\"editbutton\" onclick=\"phrc(hrcitalic);\"
										 	 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_italic.gif\" border=\"0\" title=\"Kursiv\"></td>
				            		<td><img class=\"editbutton\" onclick=\"phrc(hrcul);\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_underline.gif\" border=\"0\" title=\"Unterstrichen\"></td>
				            		<td><img class=\"editbutton\" onclick=\"phrc(hrccenter);\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_center.gif\" border=\"0\" title=\"Zentriert\"></td>

				            		<td><img src=\"{$this->ImagePath}/toolbar_separator.gif\" border=\"0\"></td>
									<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_hr.gif\" border=\"0\" onClick=\"AddToField('[hr]');\" title=\"Trennlinie\"></td>
				            		<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_image.gif\" border=\"0\" onClick=\"hrcimg();\" title=\"Bild einfügen\"></td>
				            		<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_link.gif\" border=\"0\" onClick=\"hrclink();\" title=\"Hyperlink einfügen\"></td>
				            		<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_mail.gif\" border=\"0\" onClick=\"hrcemail();\" title=\"E-Mail Link einfügen\"></td>

				            		<td><img src=\"{$this->ImagePath}/toolbar_separator.gif\" border=\"0\"></td>
									<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_quote.gif\" border=\"0\" onclick=\"phrc(hrcquote);\" title=\"Zitat\"></td>
				            		<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_ot.gif\" border=\"0\" onclick=\"phrc(hrcot);\" title=\"OffTopic\"></td>
				            		<td><img class=\"editbutton\"
											onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											src=\"{$this->ImagePath}/button_code.gif\" border=\"0\" onclick=\"phrc(hrccode);\" title=\"PHP Code\"></td>

				            		<td><img src=\"{$this->ImagePath}/toolbar_separator.gif\" border=\"0\"></td>
									<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_close.gif\" border=\"0\" onclick=\"closetags();\" title=\"Alle Tags schliessen\"></td>

									<td><img src=\"{$this->ImagePath}/toolbar_end.gif\" border=\"0\"></td>
								</tr>
							</table>
				        </td>
				    </tr>
				    <tr>
				        <td style=\"background-image:url({$this->ImagePath}/toolbar_bg.gif); font-size:11px;\" valign=\"baseline\">
				        	<table class=\"no\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">
				        		<tr>
				        			<td><img src=\"{$this->ImagePath}/toolbar_start.gif\" border=\"0\"></td>
				                	<td>Farbe:<select name=\"colour\" onChange=\"hrccolor(this.form.colour.options[this.form.colour.selectedIndex].value)\" style=\"font-size:10px;\">
										<option value=\"\">-</option>
										<option style=\"color:black; background-color: #CCCCCC\" value=\"black\">Schwarz</option>
										<option style=\"color:darkred; background-color: #CCCCCC\" value=\"darkred\">Dunkelrot</option>
										<option style=\"color:red; background-color: #CCCCCC\" value=\"red\">Rot</option>
										<option style=\"color:orange; background-color: #CCCCCC\" value=\"orange\">Orange</option>
										<option style=\"color:brown; background-color: #CCCCCC\" value=\"brown\">Braun</option>
										<option style=\"color:yellow; background-color: #CCCCCC\" value=\"yellow\">Gelb</option>
										<option style=\"color:green; background-color: #CCCCCC\" value=\"green\">Grün</option>
										<option style=\"color:olive; background-color: #CCCCCC\" value=\"olive\">Olive</option>
										<option style=\"color:cyan; background-color: #CCCCCC\" value=\"cyan\">Türkis</option>
										<option style=\"color:blue; background-color: #CCCCCC\" value=\"blue\">Blau</option>
										<option style=\"color:darkblue; background-color: #CCCCCC\" value=\"darkblue\">Dunkelblau</option>
										<option style=\"color:indigo; background-color: #CCCCCC\" value=\"indigo\">Indigo</option>
										<option style=\"color:violet; background-color: #CCCCCC\" value=\"violet\">Violett</option>
										</select></td>
									<td><img src=\"{$this->ImagePath}/toolbar_separator.gif\" border=\"0\"></td>
				                	<td>Größe:<select name=\"sizer\" onChange=\"hrcsize(this.form.sizer.options[this.form.sizer.selectedIndex].value)\" style=\"font-size:10px;\">
										<option value=\"\">-</option>
										<option value=\"8px\">8 Pixel</option>
										<option value=\"10px\">10 Pixel</option>
										<option value=\"12px\">12 Pixel</option>
										<option value=\"14px\">14 Pixel</option>
										<option value=\"16px\">16 Pixel</option>
										<option value=\"20px\">20 Pixel</option>
										</select></td>
				            		<td><img src=\"{$this->ImagePath}/toolbar_separator.gif\" border=\"0\"></td>
				                	<td>Zeichen:<input type=\"text\" size=\"5\" name=\"txtlen\" style=\"font-size:10px;\"></td>
				            		<td><img src=\"{$this->ImagePath}/toolbar_end.gif\" border=\"0\"></td>
							        <td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_resize_1.gif\" onclick=\"zoomarea(+3);\" border=\"0\" title=\"Textbox vergrössern\"></td>
				            		<td><img class=\"editbutton\"
											 onmouseover=\"pmouseover(this);\" onmouseout=\"pmouseout(this);\"
											 onmousedown=\"pmousedown(this);\" onmouseup=\"pmouseup(this);\"
											 src=\"{$this->ImagePath}/button_resize_0.gif\" onclick=\"zoomarea(-3);\" border=\"0\" title=\"Textbox verkleinern\"></td>
				            	</tr>
				            </table>
				        </td>
				    </tr>
				    </tr>
				    <tr>
				        <td colspan=\"2\">
				            <textarea name=\"{$this->InstanceName}\" id=\"{$this->InstanceName}\" rows=\"15\" cols=\"40\" wrap=\"virtual\"
				            style=\"width:{$this->Width}; height:{$this->Height};\" class=\"post\" onselect=\"storeCaret(this);\" onclick=\"storeCaret(this);\" onkeyup=\"storeCaret(this);\">".htmlspecialchars($this->Value)."</textarea>
				        </td>
				    </tr>
				</table>

				<script type=\"text/javascript\">
				// Check for Browser & Platform for PC & IE specific bits
				// More details from: http://www.mozilla.org/docs/web-developer/sniffer/browser_type.html
				var clientPC = navigator.userAgent.toLowerCase(); // Get client info
				var clientVer = parseInt(navigator.appVersion); // Get browser version

				var is_ie = ((clientPC.indexOf(\"msie\") != -1) && (clientPC.indexOf(\"opera\") == -1));
				var is_nav = ((clientPC.indexOf('mozilla')!=-1) && (clientPC.indexOf('spoofer')==-1)
				                && (clientPC.indexOf('compatible') == -1) && (clientPC.indexOf('opera')==-1)
				                && (clientPC.indexOf('webtv')==-1) && (clientPC.indexOf('hotjava')==-1));
				var is_moz = 0;

				var is_win = ((clientPC.indexOf(\"win\")!=-1) || (clientPC.indexOf(\"16bit\") != -1));
				var is_mac = (clientPC.indexOf(\"mac\")!=-1);

				//Instanz festlegen
				var instanz = document.pfform.{$this->InstanceName};

				//Startwerte
				opentags = '';

				//Tags
				hrcbold   = new Array('[b]','[/b]');
				hrcitalic = new Array('[i]','[/i]');
				hrcul     = new Array('[u]','[/u]');
				hrcquote  = new Array('[quote]','[/quote]');
				hrcot     = new Array('[ot]','[/ot]');
				hrccode   = new Array('[code]','[/code]');
				hrccenter = new Array('[center]','[/center]');

				//Selektierten Text taggen
				function phrc(hrc) {
				    if ((clientVer >= 4) && is_ie && is_win) {
						theSelection = document.selection.createRange().text;
						if (theSelection) {
							// Add tags around selection
							document.selection.createRange().text = hrc[0] + theSelection + hrc[1];
							instanz.focus();
							theSelection = '';
							return;
					    } else {
					       opentag(hrc);
					    }
				    } else if (instanz.selectionEnd && (instanz.selectionEnd - instanz.selectionStart > 0)) {
						    mozWrap(instanz, hrc[0], hrc[1]);
						    return;
					} else  {
					    opentag(hrc);
					}
					instanz.focus();
				}

				// Tag einzeln öffnen/schliessen
				function opentag(hrc) {
				    if ( opentags.indexOf(hrc[1]) != -1 ) {
				        AddCode = hrc[1];
				        opentags = opentags.replace(hrc[1],'');
				    } else {
				        AddCode = hrc[0];
				        opentags = hrc[1] + opentags;
				    }
				    AddToField(AddCode);
				}

				//Tags schliessen
				function closetags () {
					AddToField(opentags);
				    opentags = '';
				    lasttag = '';
				}

				//Caret Store
				function storeCaret(textEl) {
					if (textEl.createTextRange) textEl.caretPos = document.selection.createRange().duplicate();
					document.pfform.txtlen.value = textEl.value.length;
				}

				//Tag adden
				function AddToField(AddCode) {
				   	if ( instanz.createTextRange && instanz.caretPos )
					{
						var caretPos = instanz.caretPos;
						caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? AddCode + ' ' : AddCode;
					}
					else
					{
						instanz.value += AddCode;
					}
				    instanz.focus();
				}

				//Bild
				function hrcimg() {
				    imgurl = prompt(\"URL zum Bild eingeben:\",\"http://\");
					if ((imgurl != null) && (imgurl != \"\")) {
					    AddToField(\"[img]\"+imgurl+\"[/img] \");
				    }
				}

				//Hyperlink
				function hrclink() {
				    linktext = prompt(\"Titel des Links:\",\"\");
				    linkurl = prompt(\"URL des Links:\",\"http://\");
				 	if ((linkurl != null) && (linkurl != \"\")) {
						if ((linktext != null) && (linktext != \"\"))
							AddToField(\"[URL=\"+linkurl+\"]\"+linktext+\"[/URL] \");
						else
							AddToField(\"[URL]\"+linkurl+\"[/URL] \");
				    }
				}

				//E-Mail
				function hrcemail() {
				    linkemail = prompt(\"EMail Adresse eingeben:\",\"\");
					if ((linkemail != null) && (linkemail != \"\")) {
						AddToField(\"[EMAIL]\"+linkemail+\"[/EMAIL] \");
				    }
				}

				//textarea Grösse
				function zoomarea(size) {
				    if ( instanz.rows < 5 && size < 0 ) {
				        size = 0;
				    }
				    if ( instanz.rows > 25 && size > 0 ) {
				        size = 0;
				    }
				    instanz.rows = instanz.rows + size;
				}

				// From http://www.massless.org/mozedit/
				function mozWrap(txtarea, open, close)
				{
					var selLength = txtarea.textLength;
					var selStart = txtarea.selectionStart;
					var selEnd = txtarea.selectionEnd;
					if (selEnd == 1 || selEnd == 2)
						selEnd = selLength;

					var s1 = (txtarea.value).substring(0,selStart);
					var s2 = (txtarea.value).substring(selStart, selEnd)
					var s3 = (txtarea.value).substring(selEnd, selLength);
					txtarea.value = s1 + open + s2 + close + s3;
					return;
				}

				//Farbcode
				function hrccolor(color) {
				    code = new Array('[color=' + color + ']','[/color]');
				    phrc(code);
				}

				//Textgrösse
				function hrcsize(size) {
				    code = new Array('[size=' + size + ']','[/size]');
				    phrc(code);
				}

				//HoverClass
				function pmouseover(el) {
					el.className = \"editraise\";
				}

				function pmouseout(el) {
					el.className = \"editbutton\";
				}

				function pmousedown(el) {
					el.className = \"editpress\";
				}

				function pmouseup(el) {
					el.className = \"editraise\";
				}

				</script>
				<!-- phrc2 editor end -->
				";
		return $html;
	}
}

?>