<?php
//#############################################
//## pCal 1.0                                ##
//## 03.05.2005                              ##
//## copyright Thomas Ehrhardt , 2000-2005   ##
//## http://www.powie.de                     ##
//#############################################

function pCalTplData ( $cal ){
	//global benutzte tpl vars
	global $v_event,$v_event_list,$v_event_start,$v_event_end,$v_event_icon,$v_eventinfo,$v_eventlocation,
		   $v_eventurl,$v_color,$v_id;
	//sonstige global benutze
	global $pcal_url_catimg;
	//reset
	unset($v_event,$v_event_list,$v_event_start,$v_event_end,$v_event_icon,$v_eventinfo,$v_eventlocation,
		  $v_eventurl,$v_color,$v_id);
	//nochmal globalisieren
	global $v_event,$v_event_list,$v_event_start,$v_event_end,$v_event_icon,$v_eventinfo,$v_eventlocation,
		   $v_eventurl,$v_color,$v_id;

	//Infos holen
	$ts  = date("j",$cal['start']);
	$te  = date("j",$cal['end']);
	//setzen
	$v_id = $cal['id'];
	//Titel
	$v_event = $cal['titel'];
	//Start / Ende
	if ($cal['allday'] == 1) {
		$v_event_start = pdatum($cal['start']);
		if ( $te > $ts ) {
			$v_event_end = pdatum($cal['end']);
		}
		$v_event_end .= ' ganztgig';
	} else {
		$v_event_start = pdate($cal['start']);
		$v_event_end = pdate($cal['end']);
	}
	//Info
	$v_eventinfo = formatpost($cal['info']);
	//Icon
    $v_event_icon = "<img src=\"".$pcal_url_catimg."/".$cal['icon']."\" border=\"0\" align=\"left\" />";
    //url
    if ($cal['url'] != "") {
       	$v_eventurl = "<br />Link: <a href=\"$cal[url]\">$cal[url]</a>";
    }
    //ort
	if ($cal['location'] != "") {
	    $v_eventlocation= "<br />Ort: ".$cal['location'];
	}
	//farbcode
	if ($cal['color'] != "") {
		$v_color = " background-color:$cal[color] ";
	}
}

function pfirstkw($jahr) {
   $erster = mktime(0,0,0,1,1,$jahr);
   $wtag = date('w',$erster);

   if ($wtag <= 4) {
       /**
        * Donnerstag oder kleiner: auf den Montag zurckrechnen.
        */
       $montag = mktime(0,0,0,1,1-($wtag-1),$jahr);
   } else {
       /**
        * auf den Montag nach vorne rechnen.
        */
       $montag = mktime(0,0,0,1,1+(7-$wtag+1),$jahr);
   }
   return $montag;
}

function pmondaykw($kw,$jahr) {
   $firstmonday = pfirstkw($jahr);
   $mon_monat = date('m',$firstmonday);
   $mon_jahr = date('Y',$firstmonday);
   $mon_tage = date('d',$firstmonday);

   $tage = ($kw-1)*7;

   $mondaykw = mktime(0,0,0,$mon_monat,$mon_tage+$tage,$mon_jahr);
   return $mondaykw;
}

?>