<?php
//##############################################################################
//## pCal - Tabellen erstellen                                                ##
//##############################################################################
//##############################################################################
require_once(dirname(__file__)."/pcal_main.php");

// ########################### Tabelle Links ##########################
// id 		- Datensatz ID
// catid	- Kategorie ID
// userid   - User ID
// instanz  - erhält die ID des Start Termins bei Repeating
// title	- Titel
// info     - Textinfo
// location - Ort
// url		- Hyperlink
// start	- Timestamp Start
// end		- Timestamp Ende
// allday   - 1 = Allday Event
// status   - Status [view|check]
$sqlbefehl= "CREATE TABLE $tab_pcaldata (
   	id int(14) NOT NULL auto_increment,
    catid int(14) DEFAULT '0',
    userid int(14) DEFAULT '1',
    instanz int(14) default '0',

    titel varchar(80),
    info text,
    location varchar(100),
    url varchar(255),

    start int(14) default '0',
    end int(14) default '0',
    allday int(14) default '0',

    status varchar(20),
    PRIMARY KEY (id)
) ENGINE = MYISAM";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
echo "Tabelle $tab_pcaldata erzeugt.<br>";

// ######################### Tabelle Kategorien #######################
// catid		- ID der Kategorie
// name         - Name
// info         - Infotext
// icon         - icon Grafik
// color        - Farbcode für Anzeige
$sqlbefehl= "CREATE TABLE $tab_pcalcat (
    catid int(14) NOT NULL auto_increment,
    name varchar(100) NOT NULL,
    info text,
    icon varchar(100),
    color varchar(20),
    PRIMARY KEY (catid)
) ENGINE = MYISAM";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
//echo mysql_error();
/*
$sqlbefehl="ALTER TABLE $tab_plcat add viewtop int(14) DEFAULT '0' NOT NULL";
$ergebnis  = mysql_query($sqlbefehl, $serverid);

$sqlbefehl="ALTER TABLE $tab_plcat add pfad text";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
*/

echo "Tabelle $tab_pcalcat erzeugt.<br>";

// ######################### Tabelle PSETUP ####################################
/*$sqlbefehl= "CREATE TABLE $tab_psetup (
   id int(11) NOT NULL auto_increment,
   varname     varchar(20),
   varbase     varchar(20),
   vartext     varchar(100),
   varint      int(14),
   varlongtext text,
   PRIMARY KEY (id),
   UNIQUE id (id)
)";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
echo "Tabelle $tab_psetup erzeugt.<br>";
*/


//## Setup #####################################################################
$sqlbefehl= "CREATE TABLE $tab_setupcal (
	         dbversion varchar(20)
             ) ENGINE = MYISAM ";
$ergebnis  = mysql_query($sqlbefehl, $serverid);

//Datensatz anlegen wenn noch keiner existiert
$sqlbefehl = "Select * From $tab_setupcal";
$getsetup = mysql_query($sqlbefehl,$serverid);
if ( mysql_num_rows($getsetup) == 0 ) {
	$sqlbefehl = "Insert Into $tab_setupcal
    (dbversion)
	Values ('$pcal_version')";
	@mysql_query($sqlbefehl,$serverid);
	echo "Setup Datensatz angelegt<br />";
}
//@mysql_query(" Alter Table $tab_setupimg Add imgqual int(14) default '100' ",$serverid);
//@mysql_query(" Alter Table $tab_setupimg Add dbversion varchar(20) ",$serverid);
// Ende Setup

mysql_query("Update $tab_setupcal set dbversion = '$pcal_version'",$serverid);

//Index anlegen
echo "Index wird aufgebaut ...";

/*
$sqlbefehl="ALTER TABLE $tab_pllink drop index catid";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
$sqlbefehl="ALTER TABLE $tab_pllink ADD INDEX(catid)";
$ergebnis  = mysql_query($sqlbefehl, $serverid);

$sqlbefehl="ALTER TABLE $tab_pllink drop index titel";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
$sqlbefehl="ALTER TABLE $tab_pllink ADD INDEX(titel)";
$ergebnis  = mysql_query($sqlbefehl, $serverid);

$sqlbefehl="ALTER TABLE $tab_pllink drop index bannerrotate";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
$sqlbefehl="ALTER TABLE $tab_pllink ADD INDEX(bannerrotate)";
$ergebnis  = mysql_query($sqlbefehl, $serverid);

$sqlbefehl="ALTER TABLE $tab_pllink drop index userid";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
$sqlbefehl="ALTER TABLE $tab_pllink ADD INDEX(userid)";
$ergebnis  = mysql_query($sqlbefehl, $serverid);
*/
?>